#include <stdio.h>
#include <stdbool.h>
#include <string.h>

bool anagramme_1(char mot1[],char mot2[]);
bool anagramme_2(char mot1[],char mot2[]);
void sort(char mot[]);

void main() {
   char mot1[30];
   char mot2[30];
   printf("Entrez deux mots:\n");
   scanf("%s%s",mot1,mot2);
   printf("Les mots %s et %s",mot1,mot2);


   
   if (anagramme_1(mot1,mot2)) {
      printf(" sont des anagrammes\n");
   } else {
      printf(" ne sont pas des anagrammes\n");
   }
}

bool anagramme_1(char mot1[],char mot2[]) {
   sort(mot1);
   sort(mot2);
   return (strcmp(mot1,mot2) == 0);
}

bool anagramme_2(char mot1[],char mot2[]) {
   int lg1 = strlen(mot1), lg2 = strlen(mot2);
   bool egal = true;
   if (lg1 == lg2) {
      for (int i=0;i<lg1;i++) {
         if (mot1[i] != mot2[i]) {
            egal = false;
            break;
         }
      }
   } else {
      egal = false;
   }
   return egal;
}

int index_min(char mot[],int i) {
   int ind_min = i;
   for (int k=i+1;k<strlen(mot);k++) {
      if (mot[k] < mot[ind_min]) {
         ind_min = k;
      }
   }
   return ind_min;
}

void permut(char mot[],int i,int j) { 
   char tmp = mot[i];
   mot[i] = mot[j];
   mot[j] = tmp;
}

void sort(char mot[]) {
   int lg = strlen(mot);
   for (int i=0;i<lg-1;i++) {
      int ind_min = index_min(mot,i);
      char tmp = mot[i];
      mot[i] = mot[ind_min];
      mot[ind_min] = tmp;
   }
}
   
